#include <stdlib.h>
#include <stdio.h>
#include "3ds.h"

static bool task_quit;
static Handle task_pause_event;
static Handle task_suspend_event;
static aptHookCookie cookie;

static void task_apt_hook(APT_HookType hook, void* param) {
  switch(hook) {
  case APTHOOK_ONSUSPEND:
  svcClearEvent(task_suspend_event);
  break;
//  case APTHOOK_ONSLEEP:
//  svcClearEvent(task_pause_event);
//  break;
  default:
  break;
  }
}

void task_init() {
  task_quit = false;

  svcCreateEvent(&task_pause_event, RESET_STICKY);

  svcCreateEvent(&task_suspend_event, RESET_STICKY);

  svcSignalEvent(task_pause_event);
  svcSignalEvent(task_suspend_event);

  aptHook(&cookie, task_apt_hook, NULL);
}

void task_exit() {
  task_quit = true;

  aptUnhook(&cookie);

  if(task_pause_event != 0) {
  svcCloseHandle(task_pause_event);
  task_pause_event = 0;
  }

  if(task_suspend_event != 0) {
  svcCloseHandle(task_suspend_event);
  task_suspend_event = 0;
  }
}

bool exiting = false;
int main()
{
	cfguInit();
	gfxInitDefault();
	task_init();
	consoleInit (GFX_TOP, NULL);
	printf("Console init... ok\n");
	printf("Press Start to exit.\n");
	while (aptMainLoop() && !exiting)
	{
		hidScanInput();
		if(hidKeysDown())
			printf("Key pressed event\n");
		if(hidKeysHeld()&KEY_START) exiting=true;
		svcSleepThread(10000000);
	}
	task_exit(); // closing...
	gfxExit();
	cfguExit();
	exit(0);
}